#include <stdexcept>
#include <msp/gl/extensions/nv_half_float.h>
#include "datatype.h"

using namespace std;

namespace Msp {
namespace GL {

GLenum get_gl_type(DataType type)
{
	switch(type)
	{
	case BYTE: return GL_BYTE;
	case UNSIGNED_BYTE: return GL_UNSIGNED_BYTE;
	case SHORT: return GL_SHORT;
	case UNSIGNED_SHORT: return GL_UNSIGNED_SHORT;
	case INT: return GL_INT;
	case UNSIGNED_INT: return GL_UNSIGNED_INT;
	case FLOAT: return GL_FLOAT;
	case HALF_FLOAT: return GL_HALF_FLOAT;
	default: throw invalid_argument("get_gl_type");
	}
}

} // namespace GL
} // namespace Msp
